#!/usr/bin/env python
"""
given a json file generated by multipop.py, extract relevant details

$ jq '.monthly.averages."scaled counts".all' multipop-both-ppall_osf-2014-2016-CI0.95.json
[
  26616.93275553982,
  5507.996326101062
]
cal@system76-pc:~/pp/analyses/pop
$ jq '.weekly.averages."scaled counts".all' multipop-both-ppall_osf-2014-2016-CI0.95.json
[
  16886.601821796317,
  5893.24876608286
]
cal@system76-pc:~/pp/analyses/pop
$ jq '.weekly.all."scaled counts".all' multipop-both-ppall_osf-2014-2016-CI0.95.json
175699.21435695112
cal@system76-pc:~/pp/analyses/pop
$ jq '.weekly.all."scaled counts lower".all' multipop-both-ppall_osf-2014-2016-CI0.95.json
148252.30222698158
cal@system76-pc:~/pp/analyses/pop
$ jq '.weekly.all."scaled counts upper".all' multipop-both-ppall_osf-2014-2016-CI0.95.json
228000.36259938628
cal@system76-pc:~/pp/analyses/pop
$ jq '.monthly.all."scaled counts".all' multipop-both-ppall_osf-2014-2016-CI0.95.json
175699.21435695112

"""
import json
import sys

with open(sys.argv[1], "r") as mh:
    counts = json.load(mh)

population = {}
if len(sys.argv) > 2:
    population = json.loads(sys.argv[2])
else:
    # Canadian female 20-49 yr old population from 2016 census
    population["f"] = 7205721

for what in ["all", "f"]:
    weekly, wsd, monthly, msd, alltime, alllower, allupper = map(round, [
            counts["weekly"]["averages"]["scaled counts"][what][0], 
            counts["weekly"]["averages"]["scaled counts"][what][1], 
            counts["monthly"]["averages"]["scaled counts"][what][0], 
            counts["monthly"]["averages"]["scaled counts"][what][1], 
            counts["all"]["scaled counts"][what],
            counts["all"]["scaled counts lower"][what],
            counts["all"]["scaled counts upper"][what],
            ]
        )
    print(f"{what}:\nweekly {weekly} (SD {wsd})\nmonthly {monthly} (SD {msd})\nalltime {alltime} (CI {alllower}-{allupper})") 
    print()
    print("relative proportions:\n\tmonthly/weekly = {}\n\talltime/weekly = {}\n\talltime/monthly = {}".format(
        round(100*monthly/weekly,1), round(alltime/weekly,1), round(alltime/monthly,1)))
    print()
    if what in population:
        print("population proportions (total {}):\n\tweekly {}% (one in {})\n\tmonthly {}% (one in {})\n\talltime {}% (one in {})".format(
            population[what], 
            round(100*weekly/population[what], 1), 
            round(population[what]/weekly),
            round(100*monthly/population[what], 1), 
            round(population[what]/monthly),
            round(100*alltime/population[what], 1),
            round(population[what]/alltime)
            ))

